function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t2 = arguments[e];
      for (var r in t2) ({}).hasOwnProperty.call(t2, r) && (n[r] = t2[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
import { defineComponent, $props, $setup, $prefix } from "@opentiny/vue-common";
import { t } from "@opentiny/vue-locale";
import PcTemplate from "./pc.js";
import MobileFirstTemplate from "./mobile-first.js";
var template = function template2(mode) {
  var _process$env;
  var tinyMode = typeof process === "object" ? (_process$env = process.env) == null ? void 0 : _process$env.TINY_MODE : null;
  if ("pc" === (tinyMode || mode)) {
    return PcTemplate;
  }
  if ("mobile-first" === (tinyMode || mode)) {
    return MobileFirstTemplate;
  }
  return PcTemplate;
};
var searchProps = _extends({}, $props, {
  mini: {
    type: Boolean,
    default: false
  },
  big: {
    type: Boolean,
    default: false
  },
  buttonText: {
    type: String,
    default: function _default() {
      return t("ui.search.placeholder");
    }
  },
  /**
   * 设置为透明模式，配置为true时，边框变为透明且收缩后半透明显示，一般用在带有背景的场景
   */
  transparent: {
    type: Boolean,
    default: false
  },
  /**
   * 搜索的类型选项，格式为[{text:'文档',value:1},...]，不配置时类型选择固定显示为All
   */
  searchTypes: {
    type: Array,
    default: function _default2() {
      return [];
    }
  },
  /**
   * 设置搜索输入框内的提示占位文本
   */
  placeholder: {
    type: String,
    default: ""
  },
  modelValue: {
    type: String,
    default: ""
  },
  clearable: {
    type: Boolean,
    default: false
  },
  tabindex: {
    type: String,
    default: "1"
  },
  /**
   * 配置搜索输入框enter键,enter按下触发搜索
   */
  isEnterSearch: {
    type: Boolean,
    default: true
  },
  /**
   * 配置主题色，primary:蓝 gray:灰
   */
  themeType: {
    type: String,
    default: "primary",
    validator: function validator(value) {
      return ["primary", "gray"].includes(value);
    }
  },
  showButton: {
    type: Boolean,
    default: false
  },
  changeBgColor: {
    type: Boolean,
    default: false
  },
  size: {
    type: String,
    default: "small"
  },
  typeValue: Object,
  suffixIcon: [Object, String],
  // tiny新增
  disabled: {
    type: Boolean,
    default: false
  }
});
var Search = defineComponent({
  name: $prefix + "Search",
  props: searchProps,
  setup: function setup(props, context) {
    return $setup({
      props,
      context,
      template
    });
  }
});
var version = "3.undefined";
Search.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
Search.install = function(Vue) {
  Vue.component(Search.name, Search);
};
Search.version = version;
export {
  Search as default
};
